/*
  Copyright (C) 2016 D Levin (https://www.kfrlib.com)
  This file is part of KFR

  KFR is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KFR is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KFR.

  If GPL is not suitable for your project, you must purchase a commercial license to use KFR.
  Buying a commercial license is mandatory as soon as you develop commercial activities without
  disclosing the source code of your own applications.
  See https://www.kfrlib.com for details.
 */
#pragma once

#include "base/abs.hpp"
#include "base/asin_acos.hpp"
#include "base/atan.hpp"
#include "base/basic_expressions.hpp"
#include "base/clamp.hpp"
#include "base/compiletime.hpp"
#include "base/complex.hpp"
#include "base/constants.hpp"
#include "base/conversion.hpp"
#include "base/cpuid.hpp"
#include "base/cpuid_auto.hpp"
#include "base/digitreverse.hpp"
#include "base/expression.hpp"
#include "base/function.hpp"
#include "base/gamma.hpp"
#include "base/generators.hpp"
#include "base/hyperbolic.hpp"
#include "base/log_exp.hpp"
#include "base/logical.hpp"
#include "base/memory.hpp"
#include "base/min_max.hpp"
#include "base/modzerobessel.hpp"
#include "base/operators.hpp"
#include "base/pointer.hpp"
#include "base/random.hpp"
#include "base/read_write.hpp"
#include "base/reduce.hpp"
#include "base/round.hpp"
#include "base/saturation.hpp"
#include "base/select.hpp"
#include "base/shuffle.hpp"
#include "base/sin_cos.hpp"
#include "base/small_buffer.hpp"
#include "base/sort.hpp"
#include "base/sqrt.hpp"
#include "base/tan.hpp"
#include "base/types.hpp"
#include "base/univector.hpp"
#include "base/vec.hpp"
